commit ad60dd49408f3f9fcbe72b1ffbd1aa70a28aa000
Author: Scott Ullrich <sullrich@pfsense.org>
Date:   Sat Mar 15 23:52:29 2008 +0000

    Remove bigpond support.   It has been phased out according to:
    http://cvstrac.pfsense.com/chngview?cn=14038

diff --git a/usr/local/www/interfaces.php b/usr/local/www/interfaces.php
index 71bc7a1128..0d069a3a78 100755
--- a/usr/local/www/interfaces.php
+++ b/usr/local/www/interfaces.php
@@ -131,12 +131,6 @@ $pconfig['pptp_idletimeout'] = $config['pptp']['timeout'];
 
 $pconfig['disableftpproxy'] = isset($wancfg['disableftpproxy']);
 
-$pconfig['bigpond_username'] = $config['bigpond']['username'];
-$pconfig['bigpond_password'] = $config['bigpond']['password'];
-$pconfig['bigpond_authserver'] = $config['bigpond']['authserver'];
-$pconfig['bigpond_authdomain'] = $config['bigpond']['authdomain'];
-$pconfig['bigpond_minheartbeatinterval'] = $config['bigpond']['minheartbeatinterval'];
-
 $pconfig['dhcphostname'] = $wancfg['dhcphostname'];
 $pconfig['alias-address'] = $wancfg['alias-address'];
 $pconfig['alias-subnet'] = $wancfg['alias-subnet'];
@@ -147,8 +141,6 @@ if ($wancfg['ipaddr'] == "dhcp") {
 	$pconfig['type'] = "PPPoE";
 } else if ($wancfg['ipaddr'] == "pptp") {
 	$pconfig['type'] = "PPTP";
-} else if ($wancfg['ipaddr'] == "bigpond") {
-	$pconfig['type'] = "BigPond";
 } else {
 	$pconfig['type'] = "Static";
 	$pconfig['ipaddr'] = $wancfg['ipaddr'];
@@ -234,14 +226,10 @@ if ($_POST) {
 			$reqdfieldsn = explode(",", "PPTP username,PPTP password,PPTP local IP address,PPTP subnet,PPTP remote IP address");
 		}
 		do_input_validation($_POST, $reqdfields, $reqdfieldsn, &$input_errors);
-	} else if ($_POST['type'] == "BigPond") {
-		$reqdfields = explode(" ", "bigpond_username bigpond_password");
-		$reqdfieldsn = explode(",", "BigPond username,BigPond password");
-		do_input_validation($_POST, $reqdfields, $reqdfieldsn, &$input_errors);
 	}
 
-        /* normalize MAC addresses - lowercase and convert Windows-ized hyphenated MACs to colon delimited */
-        $_POST['spoofmac'] = strtolower(str_replace("-", ":", $_POST['spoofmac']));
+	/* normalize MAC addresses - lowercase and convert Windows-ized hyphenated MACs to colon delimited */
+	$_POST['spoofmac'] = strtolower(str_replace("-", ":", $_POST['spoofmac']));
 
 	if (($_POST['ipaddr'] && !is_ipaddr($_POST['ipaddr']))) {
 		$input_errors[] = "A valid IP address must be specified.";
@@ -297,15 +285,6 @@ if ($_POST) {
 	if (($_POST['pptp_idletimeout'] != "") && !is_numericint($_POST['pptp_idletimeout'])) {
 		$input_errors[] = "The idle timeout value must be an integer.";
 	}
-	if (($_POST['bigpond_authserver'] && !is_domain($_POST['bigpond_authserver']))) {
-		$input_errors[] = "The authentication server name contains invalid characters.";
-	}
-	if (($_POST['bigpond_authdomain'] && !is_domain($_POST['bigpond_authdomain']))) {
-		$input_errors[] = "The authentication domain name contains invalid characters.";
-	}
-	if ($_POST['bigpond_minheartbeatinterval'] && !is_numericint($_POST['bigpond_minheartbeatinterval'])) {
-		$input_errors[] = "The minimum heartbeat interval must be an integer.";
-	}
 	if (($_POST['spoofmac'] && !is_macaddr($_POST['spoofmac']))) {
 		$input_errors[] = "A valid MAC address must be specified.";
 	}
@@ -350,11 +329,6 @@ if ($_POST) {
 			unset($config['pptp']['ondemand']);
 			unset($config['pptp']['timeout']);
 		}
-		unset($config['bigpond']['username']);
-		unset($config['bigpond']['password']);
-		unset($config['bigpond']['authserver']);
-		unset($config['bigpond']['authdomain']);
-		unset($config['bigpond']['minheartbeatinterval']);
 		unset($wancfg['disableftpproxy']);
 
 		/* per interface pftpx helper */
@@ -473,13 +447,6 @@ if ($_POST) {
 			$config['pptp']['remote'] = $_POST['pptp_remote'];
 			$config['pptp']['ondemand'] = $_POST['pptp_dialondemand'] ? true : false;
 			$config['pptp']['timeout'] = $_POST['pptp_idletimeout'];
-		} else if ($_POST['type'] == "BigPond") {
-			$wancfg['ipaddr'] = "bigpond";
-			$config['bigpond']['username'] = $_POST['bigpond_username'];
-			$config['bigpond']['password'] = $_POST['bigpond_password'];
-			$config['bigpond']['authserver'] = $_POST['bigpond_authserver'];
-			$config['bigpond']['authdomain'] = $_POST['bigpond_authdomain'];
-			$config['bigpond']['minheartbeatinterval'] = $_POST['bigpond_minheartbeatinterval'];
 		}
     
 		/* reset cron items if necessary */
@@ -584,11 +551,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 		case 1:
@@ -610,11 +572,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 0;
 			break;
 		case 2:
@@ -638,11 +595,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 		case 3:
@@ -668,11 +620,6 @@ function type_change(enable_change,enable_change_pptp) {
 			} else {
 				document.iform.pptp_idletimeout.disabled = 1;
 			}
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 		case 4:
@@ -694,11 +641,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 0;
-			document.iform.bigpond_password.disabled = 0;
-			document.iform.bigpond_authserver.disabled = 0;
-			document.iform.bigpond_authdomain.disabled = 0;
-			document.iform.bigpond_minheartbeatinterval.disabled = 0;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 	}
@@ -725,7 +667,7 @@ function show_mon_config() {
                 <tr>
                   <td valign="middle" class="vncell"><strong>Type</strong></td>
                   <td class="vtable"> <select name="type" class="formselect" id="type" onchange="type_change()">
-                      <?php $opts = split(" ", "Static DHCP PPPoE PPTP BigPond");
+                      <?php $opts = split(" ", "Static DHCP PPPoE PPTP");
 				foreach ($opts as $opt): ?>
                       <option <?php if ($opt == $pconfig['type']) echo "selected";?>>
                       <?=htmlspecialchars($opt);?>
@@ -978,41 +920,6 @@ seconds<br>If no qualifying outgoing packets are transmitted for the specified n
                 <tr>
                   <td colspan="2" valign="top" height="16"></td>
                 </tr>
-                <tr>
-                  <td colspan="2" valign="top" class="listtopic">BigPond Cable configuration</td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncellreq">Username</td>
-                  <td class="vtable"><input name="bigpond_username" type="text" class="formfld user" id="bigpond_username" size="20" value="<?=htmlspecialchars($pconfig['bigpond_username']);?>">
-                  </td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncellreq">Password</td>
-                  <td class="vtable"><input name="bigpond_password" type="text" class="formfld pwd" id="bigpond_password" size="20" value="<?=htmlspecialchars($pconfig['bigpond_password']);?>">
-                  </td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncell">Authentication server</td>
-                  <td class="vtable"><input name="bigpond_authserver" type="text" class="formfld unknown" id="bigpond_authserver" size="20" value="<?=htmlspecialchars($pconfig['bigpond_authserver']);?>">
-                    <br>
-                  <span class="vexpl">If this field is left empty, the default (&quot;dce-server&quot;) is used. </span></td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncell">Authentication domain</td>
-                  <td class="vtable"><input name="bigpond_authdomain" type="text" class="formfld unknown" id="bigpond_authdomain" size="20" value="<?=htmlspecialchars($pconfig['bigpond_authdomain']);?>">
-                    <br>
-                  <span class="vexpl">If this field is left empty, the domain name assigned via DHCP will be used.<br>
-                  <br>
-                  Note: the BigPond client implicitly sets the &quot;Allow DNS server list to be overridden by DHCP/PPP on WAN&quot; on the System: General setup page.            </span></td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncell">Min. heartbeat interval</td>
-                  <td class="vtable">
-                    <input name="bigpond_minheartbeatinterval" type="text" class="formfld unknown" id="bigpond_minheartbeatinterval" size="8" value="<?=htmlspecialchars($pconfig['bigpond_minheartbeatinterval']);?>">seconds<br>Setting this to a sensible value (e.g. 60 seconds) can protect against DoS attacks. </td>
-                </tr>
-                <tr>
-                  <td colspan="2" valign="top" height="16"></td>
-                </tr>
                 <tr>
                   <td colspan="2" valign="top" class="listtopic">Other</td>
                 </tr>
diff --git a/usr/local/www/interfaces_wan.php b/usr/local/www/interfaces_wan.php
index 71bc7a1128..0d069a3a78 100755
--- a/usr/local/www/interfaces_wan.php
+++ b/usr/local/www/interfaces_wan.php
@@ -131,12 +131,6 @@ $pconfig['pptp_idletimeout'] = $config['pptp']['timeout'];
 
 $pconfig['disableftpproxy'] = isset($wancfg['disableftpproxy']);
 
-$pconfig['bigpond_username'] = $config['bigpond']['username'];
-$pconfig['bigpond_password'] = $config['bigpond']['password'];
-$pconfig['bigpond_authserver'] = $config['bigpond']['authserver'];
-$pconfig['bigpond_authdomain'] = $config['bigpond']['authdomain'];
-$pconfig['bigpond_minheartbeatinterval'] = $config['bigpond']['minheartbeatinterval'];
-
 $pconfig['dhcphostname'] = $wancfg['dhcphostname'];
 $pconfig['alias-address'] = $wancfg['alias-address'];
 $pconfig['alias-subnet'] = $wancfg['alias-subnet'];
@@ -147,8 +141,6 @@ if ($wancfg['ipaddr'] == "dhcp") {
 	$pconfig['type'] = "PPPoE";
 } else if ($wancfg['ipaddr'] == "pptp") {
 	$pconfig['type'] = "PPTP";
-} else if ($wancfg['ipaddr'] == "bigpond") {
-	$pconfig['type'] = "BigPond";
 } else {
 	$pconfig['type'] = "Static";
 	$pconfig['ipaddr'] = $wancfg['ipaddr'];
@@ -234,14 +226,10 @@ if ($_POST) {
 			$reqdfieldsn = explode(",", "PPTP username,PPTP password,PPTP local IP address,PPTP subnet,PPTP remote IP address");
 		}
 		do_input_validation($_POST, $reqdfields, $reqdfieldsn, &$input_errors);
-	} else if ($_POST['type'] == "BigPond") {
-		$reqdfields = explode(" ", "bigpond_username bigpond_password");
-		$reqdfieldsn = explode(",", "BigPond username,BigPond password");
-		do_input_validation($_POST, $reqdfields, $reqdfieldsn, &$input_errors);
 	}
 
-        /* normalize MAC addresses - lowercase and convert Windows-ized hyphenated MACs to colon delimited */
-        $_POST['spoofmac'] = strtolower(str_replace("-", ":", $_POST['spoofmac']));
+	/* normalize MAC addresses - lowercase and convert Windows-ized hyphenated MACs to colon delimited */
+	$_POST['spoofmac'] = strtolower(str_replace("-", ":", $_POST['spoofmac']));
 
 	if (($_POST['ipaddr'] && !is_ipaddr($_POST['ipaddr']))) {
 		$input_errors[] = "A valid IP address must be specified.";
@@ -297,15 +285,6 @@ if ($_POST) {
 	if (($_POST['pptp_idletimeout'] != "") && !is_numericint($_POST['pptp_idletimeout'])) {
 		$input_errors[] = "The idle timeout value must be an integer.";
 	}
-	if (($_POST['bigpond_authserver'] && !is_domain($_POST['bigpond_authserver']))) {
-		$input_errors[] = "The authentication server name contains invalid characters.";
-	}
-	if (($_POST['bigpond_authdomain'] && !is_domain($_POST['bigpond_authdomain']))) {
-		$input_errors[] = "The authentication domain name contains invalid characters.";
-	}
-	if ($_POST['bigpond_minheartbeatinterval'] && !is_numericint($_POST['bigpond_minheartbeatinterval'])) {
-		$input_errors[] = "The minimum heartbeat interval must be an integer.";
-	}
 	if (($_POST['spoofmac'] && !is_macaddr($_POST['spoofmac']))) {
 		$input_errors[] = "A valid MAC address must be specified.";
 	}
@@ -350,11 +329,6 @@ if ($_POST) {
 			unset($config['pptp']['ondemand']);
 			unset($config['pptp']['timeout']);
 		}
-		unset($config['bigpond']['username']);
-		unset($config['bigpond']['password']);
-		unset($config['bigpond']['authserver']);
-		unset($config['bigpond']['authdomain']);
-		unset($config['bigpond']['minheartbeatinterval']);
 		unset($wancfg['disableftpproxy']);
 
 		/* per interface pftpx helper */
@@ -473,13 +447,6 @@ if ($_POST) {
 			$config['pptp']['remote'] = $_POST['pptp_remote'];
 			$config['pptp']['ondemand'] = $_POST['pptp_dialondemand'] ? true : false;
 			$config['pptp']['timeout'] = $_POST['pptp_idletimeout'];
-		} else if ($_POST['type'] == "BigPond") {
-			$wancfg['ipaddr'] = "bigpond";
-			$config['bigpond']['username'] = $_POST['bigpond_username'];
-			$config['bigpond']['password'] = $_POST['bigpond_password'];
-			$config['bigpond']['authserver'] = $_POST['bigpond_authserver'];
-			$config['bigpond']['authdomain'] = $_POST['bigpond_authdomain'];
-			$config['bigpond']['minheartbeatinterval'] = $_POST['bigpond_minheartbeatinterval'];
 		}
     
 		/* reset cron items if necessary */
@@ -584,11 +551,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 		case 1:
@@ -610,11 +572,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 0;
 			break;
 		case 2:
@@ -638,11 +595,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 		case 3:
@@ -668,11 +620,6 @@ function type_change(enable_change,enable_change_pptp) {
 			} else {
 				document.iform.pptp_idletimeout.disabled = 1;
 			}
-			document.iform.bigpond_username.disabled = 1;
-			document.iform.bigpond_password.disabled = 1;
-			document.iform.bigpond_authserver.disabled = 1;
-			document.iform.bigpond_authdomain.disabled = 1;
-			document.iform.bigpond_minheartbeatinterval.disabled = 1;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 		case 4:
@@ -694,11 +641,6 @@ function type_change(enable_change,enable_change_pptp) {
 			document.iform.pptp_remote.disabled = 1;
 			document.iform.pptp_dialondemand.disabled = 1;
 			document.iform.pptp_idletimeout.disabled = 1;
-			document.iform.bigpond_username.disabled = 0;
-			document.iform.bigpond_password.disabled = 0;
-			document.iform.bigpond_authserver.disabled = 0;
-			document.iform.bigpond_authdomain.disabled = 0;
-			document.iform.bigpond_minheartbeatinterval.disabled = 0;
 			document.iform.dhcphostname.disabled = 1;
 			break;
 	}
@@ -725,7 +667,7 @@ function show_mon_config() {
                 <tr>
                   <td valign="middle" class="vncell"><strong>Type</strong></td>
                   <td class="vtable"> <select name="type" class="formselect" id="type" onchange="type_change()">
-                      <?php $opts = split(" ", "Static DHCP PPPoE PPTP BigPond");
+                      <?php $opts = split(" ", "Static DHCP PPPoE PPTP");
 				foreach ($opts as $opt): ?>
                       <option <?php if ($opt == $pconfig['type']) echo "selected";?>>
                       <?=htmlspecialchars($opt);?>
@@ -978,41 +920,6 @@ seconds<br>If no qualifying outgoing packets are transmitted for the specified n
                 <tr>
                   <td colspan="2" valign="top" height="16"></td>
                 </tr>
-                <tr>
-                  <td colspan="2" valign="top" class="listtopic">BigPond Cable configuration</td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncellreq">Username</td>
-                  <td class="vtable"><input name="bigpond_username" type="text" class="formfld user" id="bigpond_username" size="20" value="<?=htmlspecialchars($pconfig['bigpond_username']);?>">
-                  </td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncellreq">Password</td>
-                  <td class="vtable"><input name="bigpond_password" type="text" class="formfld pwd" id="bigpond_password" size="20" value="<?=htmlspecialchars($pconfig['bigpond_password']);?>">
-                  </td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncell">Authentication server</td>
-                  <td class="vtable"><input name="bigpond_authserver" type="text" class="formfld unknown" id="bigpond_authserver" size="20" value="<?=htmlspecialchars($pconfig['bigpond_authserver']);?>">
-                    <br>
-                  <span class="vexpl">If this field is left empty, the default (&quot;dce-server&quot;) is used. </span></td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncell">Authentication domain</td>
-                  <td class="vtable"><input name="bigpond_authdomain" type="text" class="formfld unknown" id="bigpond_authdomain" size="20" value="<?=htmlspecialchars($pconfig['bigpond_authdomain']);?>">
-                    <br>
-                  <span class="vexpl">If this field is left empty, the domain name assigned via DHCP will be used.<br>
-                  <br>
-                  Note: the BigPond client implicitly sets the &quot;Allow DNS server list to be overridden by DHCP/PPP on WAN&quot; on the System: General setup page.            </span></td>
-                </tr>
-                <tr>
-                  <td valign="top" class="vncell">Min. heartbeat interval</td>
-                  <td class="vtable">
-                    <input name="bigpond_minheartbeatinterval" type="text" class="formfld unknown" id="bigpond_minheartbeatinterval" size="8" value="<?=htmlspecialchars($pconfig['bigpond_minheartbeatinterval']);?>">seconds<br>Setting this to a sensible value (e.g. 60 seconds) can protect against DoS attacks. </td>
-                </tr>
-                <tr>
-                  <td colspan="2" valign="top" height="16"></td>
-                </tr>
                 <tr>
                   <td colspan="2" valign="top" class="listtopic">Other</td>
                 </tr>