commit b1d64b46e38bdc298b11369f298995c851aad938
Author: Chris Buechler <cmb@pfsense.org>
Date:   Fri Mar 14 19:33:49 2014 -0500

    standardize URLs

diff --git a/etc/rc.captiveportal_configure b/etc/rc.captiveportal_configure
index 57e99f7e36..bd59361a18 100755
--- a/etc/rc.captiveportal_configure
+++ b/etc/rc.captiveportal_configure
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.captiveportal_configure
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.carpbackup b/etc/rc.carpbackup
index d463d45f41..fbfcaacfe8 100755
--- a/etc/rc.carpbackup
+++ b/etc/rc.carpbackup
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.carpdown
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.carpmaster b/etc/rc.carpmaster
index 50db028499..aa364009aa 100755
--- a/etc/rc.carpmaster
+++ b/etc/rc.carpmaster
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.carpup
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.conf_mount_ro b/etc/rc.conf_mount_ro
index 6e1ba2fcad..9e82fecdf8 100755
--- a/etc/rc.conf_mount_ro
+++ b/etc/rc.conf_mount_ro
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.conf_mount_ro
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.conf_mount_rw b/etc/rc.conf_mount_rw
index ecd7577fa7..45d25e29a8 100755
--- a/etc/rc.conf_mount_rw
+++ b/etc/rc.conf_mount_rw
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.conf_mount_rw
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.dhclient_cron b/etc/rc.dhclient_cron
index c57b15b5ff..3ffb46edad 100755
--- a/etc/rc.dhclient_cron
+++ b/etc/rc.dhclient_cron
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.dhclient_cron
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2006 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.dyndns.update b/etc/rc.dyndns.update
index 006e1607b9..e537657392 100755
--- a/etc/rc.dyndns.update
+++ b/etc/rc.dyndns.update
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.dyndns.update
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.filter_configure b/etc/rc.filter_configure
index c91313db62..92be68da1c 100755
--- a/etc/rc.filter_configure
+++ b/etc/rc.filter_configure
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.filter_configure
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.filter_configure_sync b/etc/rc.filter_configure_sync
index 85458eed2f..1f3668141e 100755
--- a/etc/rc.filter_configure_sync
+++ b/etc/rc.filter_configure_sync
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.filter_configure_sync
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.interfaces_carp_configure b/etc/rc.interfaces_carp_configure
index cdff0b507d..fb1f1131a0 100755
--- a/etc/rc.interfaces_carp_configure
+++ b/etc/rc.interfaces_carp_configure
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.interfaces_carp_configure
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.interfaces_lan_configure b/etc/rc.interfaces_lan_configure
index e500a72ec7..eafe74d441 100755
--- a/etc/rc.interfaces_lan_configure
+++ b/etc/rc.interfaces_lan_configure
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.interfaces_lan_configure
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.interfaces_opt_configure b/etc/rc.interfaces_opt_configure
index 86f5e3880b..57da3419e5 100755
--- a/etc/rc.interfaces_opt_configure
+++ b/etc/rc.interfaces_opt_configure
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.interfaces_opt_configure
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.interfaces_wan_configure b/etc/rc.interfaces_wan_configure
index 3969777422..d939383fd8 100755
--- a/etc/rc.interfaces_wan_configure
+++ b/etc/rc.interfaces_wan_configure
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.interfaces_wan_configure
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.notify_message b/etc/rc.notify_message
index b2b5f04409..8e51785585 100755
--- a/etc/rc.notify_message
+++ b/etc/rc.notify_message
@@ -2,7 +2,7 @@
 <?php
 /*
     rc.notify_message
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2010 Scott Ullrich <sullrich@gmail.com>
     All rights reserved.
 
diff --git a/etc/rc.packages b/etc/rc.packages
index 3dae6deb89..c56cf84cae 100755
--- a/etc/rc.packages
+++ b/etc/rc.packages
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.packages
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.reload_all b/etc/rc.reload_all
index fed04a9b77..00dc4efc5f 100755
--- a/etc/rc.reload_all
+++ b/etc/rc.reload_all
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.reload_all
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.reload_interfaces b/etc/rc.reload_interfaces
index 241b883822..329bf476e6 100755
--- a/etc/rc.reload_interfaces
+++ b/etc/rc.reload_interfaces
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.reload_interfaces
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/etc/rc.start_packages b/etc/rc.start_packages
index 3d30587718..bfeb7763f8 100755
--- a/etc/rc.start_packages
+++ b/etc/rc.start_packages
@@ -3,7 +3,7 @@
 /* $Id$ */
 /*
     rc.start_packages
-    part of pfSense (http://www.pfSense.com)
+    part of pfSense (https://www.pfsense.org)
     Copyright (C) 2004 Scott Ullrich
     All rights reserved.
 
diff --git a/usr/local/www/pkg_mgr_install.php b/usr/local/www/pkg_mgr_install.php
index 3ec8a86d0f..b942434c50 100755
--- a/usr/local/www/pkg_mgr_install.php
+++ b/usr/local/www/pkg_mgr_install.php
@@ -2,7 +2,7 @@
 /* $Id$ */
 /*
 	pkg_mgr_install.php
-	part of pfSense (http://www.pfSense.com)
+	part of pfSense (https://www.pfsense.org)
 	Copyright (C) 2004-2010 Scott Ullrich <sullrich@gmail.com>
  	Copyright (C) 2005 Colin Smith
 	All rights reserved.