commit 5aa68a55a6724f32b934bab2ce6d1e939868979d
Author: Renato Botelho <garga@FreeBSD.org>
Date:   Sun Jul 28 10:31:14 2013 -0300

    Fix #3113, fix multiple english spell errors s/seperet/separat/

diff --git a/etc/inc/gwlb.inc b/etc/inc/gwlb.inc
index 9f7ebf7914..3f9e1fe656 100644
--- a/etc/inc/gwlb.inc
+++ b/etc/inc/gwlb.inc
@@ -676,7 +676,7 @@ function return_gateway_groups_array() {
 	if (is_array($config['gateways']['gateway_group'])) {
 		$carplist = get_configured_carp_interface_list();
 		foreach ($config['gateways']['gateway_group'] as $group) {
-			/* create array with group gateways members seperated by tier */
+			/* create array with group gateways members separated by tier */
 			$tiers = array();
 			$backupplan = array();
 			$gwvip_arr = array();
diff --git a/etc/inc/pfsense-utils.inc b/etc/inc/pfsense-utils.inc
index c22de254db..1af6ad0173 100644
--- a/etc/inc/pfsense-utils.inc
+++ b/etc/inc/pfsense-utils.inc
@@ -1811,9 +1811,9 @@ function update_progress_bar($percent, $first_time) {
 
 /* Split() is being DEPRECATED as of PHP 5.3.0 and REMOVED as of PHP 6.0.0. Relying on this feature is highly discouraged. */
 if(!function_exists("split")) {
-	function split($seperator, $haystack, $limit = null) {
-		log_error("deprecated split() call with seperator '{$seperator}'");
-		return preg_split($seperator, $haystack, $limit);
+	function split($separator, $haystack, $limit = null) {
+		log_error("deprecated split() call with separator '{$separator}'");
+		return preg_split($separator, $haystack, $limit);
 	}
 }
 
diff --git a/etc/inc/simplepie/simplepie.inc b/etc/inc/simplepie/simplepie.inc
index 21cc5d24eb..8fd3c624e7 100644
--- a/etc/inc/simplepie/simplepie.inc
+++ b/etc/inc/simplepie/simplepie.inc
@@ -10738,7 +10738,7 @@ class SimplePie_Misc
 		return (bool) preg_match('/^([A-Za-z0-9\-._~\x{A0}-\x{D7FF}\x{F900}-\x{FDCF}\x{FDF0}-\x{FFEF}\x{10000}-\x{1FFFD}\x{20000}-\x{2FFFD}\x{30000}-\x{3FFFD}\x{40000}-\x{4FFFD}\x{50000}-\x{5FFFD}\x{60000}-\x{6FFFD}\x{70000}-\x{7FFFD}\x{80000}-\x{8FFFD}\x{90000}-\x{9FFFD}\x{A0000}-\x{AFFFD}\x{B0000}-\x{BFFFD}\x{C0000}-\x{CFFFD}\x{D0000}-\x{DFFFD}\x{E1000}-\x{EFFFD}!$&\'()*+,;=@]|(%[0-9ABCDEF]{2}))+$/u', $string);
 	}
 
-	function space_seperated_tokens($string)
+	function space_separated_tokens($string)
 	{
 		$space_characters = "\x20\x09\x0A\x0B\x0C\x0D";
 		$string_length = strlen($string);
@@ -11830,7 +11830,7 @@ class SimplePie_Parse_Date
 	/**
 	 * Parse a superset of W3C-DTF (allows hyphens and colons to be omitted, as
 	 * well as allowing any of upper or lower case "T", horizontal tabs, or
-	 * spaces to be used as the time seperator (including more than one))
+	 * spaces to be used as the time separator (including more than one))
 	 *
 	 * @access protected
 	 * @return int Timestamp
@@ -12904,7 +12904,7 @@ class SimplePie_Locator
 			}
 			if (isset($link['attribs']['href']['data']) && isset($link['attribs']['rel']['data']))
 			{
-				$rel = array_unique(SimplePie_Misc::space_seperated_tokens(strtolower($link['attribs']['rel']['data'])));
+				$rel = array_unique(SimplePie_Misc::space_separated_tokens(strtolower($link['attribs']['rel']['data'])));
 
 				if ($this->base_location < $link['offset'])
 				{
@@ -13669,4 +13669,4 @@ class SimplePie_Sanitize
 	}
 }
 
-?>
\ No newline at end of file
+?>
diff --git a/etc/rc b/etc/rc
index fcb2c32e6a..9baac4e407 100755
--- a/etc/rc
+++ b/etc/rc
@@ -255,7 +255,7 @@ fi
 # Setup compatibility link for packages that
 # have trouble overriding the PREFIX configure
 # argument since we build our packages in a
-# seperated PREFIX area
+# separated PREFIX area
 # Only create if symlink does not exist. 
 if [ ! -h /tmp/tmp ]; then
     /bin/ln -hfs / /tmp/tmp
diff --git a/usr/local/bin/3gstats.php b/usr/local/bin/3gstats.php
index 05c18c9066..02f1b170fe 100755
--- a/usr/local/bin/3gstats.php
+++ b/usr/local/bin/3gstats.php
@@ -11,7 +11,7 @@ if(empty($argv[1])) {
 /* Huawei example */
 $device = "/dev/{$argv[1]}";
 $statfile = "/tmp/3gstats.{$argv[2]}";
-/* mode is a comma seperated value, thus submode is born */
+/* mode is a comma separated value, thus submode is born */
 $header = "#seconds,rssi,mode,submode,upstream,downstream,sentbytes,receivedbyts,bwupstream,bwdownstream,simstate,service\n";
 
 $i = 0;
diff --git a/usr/local/sbin/pbi_create b/usr/local/sbin/pbi_create
index 3594f67379..e02a8a1eac 100755
--- a/usr/local/sbin/pbi_create
+++ b/usr/local/sbin/pbi_create
@@ -318,7 +318,7 @@ Options:
   --key key    		-- Path to the public key file for this repo
   --url url    		-- Base URL for fetching the INDEX files
   --mirror mirrorurl 	-- Mirror url(s) for fetching PBIs, use ',' as 
-			   seperator for multiple
+			   separator for multiple
 
 EOF
         exit_trap
diff --git a/usr/local/share/protocols/dhcp.pat b/usr/local/share/protocols/dhcp.pat
index fbda7de194..426480d491 100644
--- a/usr/local/share/protocols/dhcp.pat
+++ b/usr/local/share/protocols/dhcp.pat
@@ -18,7 +18,7 @@ dhcp
 # Let's break that down:
 #
 # (\x01|\x02) is for BOOTREQUEST or BOOTREPLY
-# Is there a demand for doing these seperately?  The Packeteer does.
+# Is there a demand for doing these separately?  The Packeteer does.
 #
 # [\x01-\x20] is for any of the hardware address types listed at
 # (http://www.iana.org/assignments/arp-parameters) and hopefully faster 
diff --git a/usr/local/www/firewall_aliases_edit.php b/usr/local/www/firewall_aliases_edit.php
index 51b8fff556..74c26f9b54 100755
--- a/usr/local/www/firewall_aliases_edit.php
+++ b/usr/local/www/firewall_aliases_edit.php
@@ -500,7 +500,7 @@ $update_freq_str = gettext("Update Freq.");
 
 $networks_help = gettext("Networks are specified in CIDR format.  Select the CIDR mask that pertains to each entry. /32 specifies a single IPv4 host, /128 specifies a single IPv6 host, /24 specifies 255.255.255.0, /64 specifies a normal IPv6 network, etc. Hostnames (FQDNs) may also be specified, using a /32 mask for IPv4 or /128 for IPv6. You may also enter an IP range such as 192.168.1.1-192.168.1.254 and a list of CIDR networks will be derived to fill the range.");
 $hosts_help = gettext("Enter as many hosts as you would like.  Hosts must be specified by their IP address or fully qualified domain name (FQDN). FQDN hostnames are periodically re-resolved and updated. If multiple IPs are returned by a DNS query, all are used.");
-$ports_help = gettext("Enter as many ports as you wish.  Port ranges can be expressed by seperating with a colon.");
+$ports_help = gettext("Enter as many ports as you wish.  Port ranges can be expressed by separating with a colon.");
 $url_help = sprintf(gettext("Enter as many URLs as you wish. After saving %s will download the URL and import the items into the alias. Use only with small sets of IP addresses (less than 3000)."), $g['product_name']);
 $url_ports_help = sprintf(gettext("Enter as many URLs as you wish. After saving %s will download the URL and import the items into the alias. Use only with small sets of Ports (less than 3000)."), $g['product_name']);
 $urltable_help = sprintf(gettext("Enter a single URL containing a large number of IPs and/or Subnets. After saving %s will download the URL and create a table file containing these addresses. This will work with large numbers of addresses (30,000+) or small numbers."), $g['product_name']);
diff --git a/usr/local/www/javascript/domTT/behaviour.js b/usr/local/www/javascript/domTT/behaviour.js
index d86df13b2c..8ba34f790d 100644
--- a/usr/local/www/javascript/domTT/behaviour.js
+++ b/usr/local/www/javascript/domTT/behaviour.js
@@ -194,7 +194,7 @@ document.getElementsBySelector = function(selector) {
         case '=': // Equality
           checkFunction = function(e) { return (e.getAttribute(attrName) == attrValue); };
           break;
-        case '~': // Match one of space seperated words 
+        case '~': // Match one of space separated words 
           checkFunction = function(e) { return (e.getAttribute(attrName).match(new RegExp('\\b'+attrValue+'\\b'))); };
           break;
         case '|': // Match start with value followed by optional hyphen
diff --git a/usr/local/www/javascript/jquery-ui-timepicker-addon/js/jquery-ui-timepicker-addon.js b/usr/local/www/javascript/jquery-ui-timepicker-addon/js/jquery-ui-timepicker-addon.js
index f83839ee48..4a908bba24 100644
--- a/usr/local/www/javascript/jquery-ui-timepicker-addon/js/jquery-ui-timepicker-addon.js
+++ b/usr/local/www/javascript/jquery-ui-timepicker-addon/js/jquery-ui-timepicker-addon.js
@@ -245,7 +245,7 @@ $.extend(Timepicker.prototype, {
 			// the time should come after x number of characters and a space.
 			// x = at least the length of text specified by the date format
 			var dp_dateFormat = $.datepicker._get(this.inst, 'dateFormat');
-			// escape special regex characters in the seperator
+			// escape special regex characters in the separator
 			var specials = new RegExp("[.*+?|()\\[\\]{}\\\\]", "g");
 			regstr = '^.{' + dp_dateFormat.length + ',}?' + this._defaults.separator.replace(specials, "\\$&") + regstr;
 		}
diff --git a/usr/local/www/javascript/jquery.js b/usr/local/www/javascript/jquery.js
index f3201aacb6..7883c5c605 100644
--- a/usr/local/www/javascript/jquery.js
+++ b/usr/local/www/javascript/jquery.js
@@ -2029,7 +2029,7 @@ jQuery.fn.extend({
 					classNames = value.split( rspace );
 
 				while ( (className = classNames[ i++ ]) ) {
-					// check each className given, space seperated list
+					// check each className given, space separated list
 					state = isBool ? state : !self.hasClass( className );
 					self[ state ? "addClass" : "removeClass" ]( className );
 				}
diff --git a/usr/local/www/pkg_edit.php b/usr/local/www/pkg_edit.php
index 26dd6a4b23..0f9827cda4 100755
--- a/usr/local/www/pkg_edit.php
+++ b/usr/local/www/pkg_edit.php
@@ -1080,10 +1080,10 @@ function parse_package_templates() {
 								$row_helper_data .= $value;
 								$sep = "";
 								ereg($rowhelperfield['fieldname'] . "_fieldvalue\[(.*)\]", $template_text, $sep);
-								foreach ($sep as $se) $seperator = $se;
-								if($seperator <> "") {
-							    	$row_helper_data = ereg_replace("  ", $seperator, $row_helper_data);
-							    	$template_text = ereg_replace("\[{$seperator}\]", "", $template_text);
+								foreach ($sep as $se) $separator = $se;
+								if($separator <> "") {
+							    	$row_helper_data = ereg_replace("  ", $separator, $row_helper_data);
+							    	$template_text = ereg_replace("\[{$separator}\]", "", $template_text);
 									}
 								$template_text = str_replace($rowhelperfield['fieldname'] . "_fieldvalue", $row_helper_data, $template_text);
 								}
diff --git a/usr/local/www/services_dhcp.php b/usr/local/www/services_dhcp.php
index eeafd113af..3b136c929b 100755
--- a/usr/local/www/services_dhcp.php
+++ b/usr/local/www/services_dhcp.php
@@ -904,7 +904,7 @@ include("head.inc");
 			<td width="22%" valign="top" class="vncell"><?=gettext("Domain search list");?></td>
 			<td width="78%" class="vtable">
 				<input name="domainsearchlist" type="text" class="formfld unknown" id="domainsearchlist" size="20" value="<?=htmlspecialchars($pconfig['domainsearchlist']);?>"><br>
-				<?=gettext("The DHCP server can optionally provide a domain search list. Use the semicolon character as seperator ");?>
+				<?=gettext("The DHCP server can optionally provide a domain search list. Use the semicolon character as separator ");?>
 			</td>
 			</tr>
 			<tr>
diff --git a/usr/local/www/services_dhcp_edit.php b/usr/local/www/services_dhcp_edit.php
index a90c3a6287..281d754539 100755
--- a/usr/local/www/services_dhcp_edit.php
+++ b/usr/local/www/services_dhcp_edit.php
@@ -436,7 +436,7 @@ include("head.inc");
 		<td width="22%" valign="top" class="vncell"><?=gettext("Domain search list");?></td>
 		<td width="78%" class="vtable">
 			<input name="domainsearchlist" type="text" class="formfld unknown" id="domainsearchlist" size="20" value="<?=htmlspecialchars($pconfig['domainsearchlist']);?>"><br>
-			<?=gettext("The DHCP server can optionally provide a domain search list. Use the semicolon character as seperator ");?>
+			<?=gettext("The DHCP server can optionally provide a domain search list. Use the semicolon character as separator ");?>
 		</td>
 		</tr>
 		<tr>
diff --git a/usr/local/www/services_dhcpv6.php b/usr/local/www/services_dhcpv6.php
index 51f6208e45..ce87acd2a6 100644
--- a/usr/local/www/services_dhcpv6.php
+++ b/usr/local/www/services_dhcpv6.php
@@ -630,7 +630,7 @@ display_top_tabs($tab_array);
 			<td width="22%" valign="top" class="vncell"><?=gettext("Domain search list");?></td>
 			<td width="78%" class="vtable">
 				<input name="domainsearchlist" type="text" class="formfld unknown" id="domainsearchlist" size="28" value="<?=htmlspecialchars($pconfig['domainsearchlist']);?>"><br>
-				<?=gettext("The DHCP server can optionally provide a domain search list. Use the semicolon character as seperator");?>
+				<?=gettext("The DHCP server can optionally provide a domain search list. Use the semicolon character as separator");?>
 			</td>
 			</tr>
 			<tr>
diff --git a/usr/local/www/services_router_advertisements.php b/usr/local/www/services_router_advertisements.php
index 773cb6fef1..4b58331450 100644
--- a/usr/local/www/services_router_advertisements.php
+++ b/usr/local/www/services_router_advertisements.php
@@ -376,7 +376,7 @@ display_top_tabs($tab_array);
 			<td width="22%" valign="top" class="vncell"><?=gettext("Domain search list");?></td>
 			<td width="78%" class="vtable">
 				<input name="radomainsearchlist" type="text" class="formfld unknown" id="radomainsearchlist" size="28" value="<?=htmlspecialchars($pconfig['radomainsearchlist']);?>"><br>
-				<?=gettext("The RA server can optionally provide a domain search list. Use the semicolon character as seperator");?>
+				<?=gettext("The RA server can optionally provide a domain search list. Use the semicolon character as separator");?>
 			</td>
 			</tr>
 
diff --git a/usr/local/www/tree/tree.js b/usr/local/www/tree/tree.js
index c6d86c2f89..0408e866d3 100644
--- a/usr/local/www/tree/tree.js
+++ b/usr/local/www/tree/tree.js
@@ -1,5 +1,5 @@
 /*
- * Content-seperated javascript tree widget
+ * Content-separated javascript tree widget
  * Copyright (C) 2005 SilverStripe Limited
  * Feel free to use this on your websites, but please leave this message in the fies
  * http://www.silverstripe.com/blog